Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limvar.F90	(revision 3938)
@@ -53,4 +53,5 @@
    USE lib_mpp          ! MPP library
    USE wrk_nemo         ! work arrays
+   USE lib_fortran      ! to use key_nosignedzero
 
    IMPLICIT NONE
@@ -61,12 +62,13 @@
    PUBLIC   lim_var_eqv2glo      !
    PUBLIC   lim_var_salprof      !
+   PUBLIC   lim_var_icetm        !
    PUBLIC   lim_var_bv           !
    PUBLIC   lim_var_salprof1d    !
 
-   REAL(wp) ::   eps20 = 1.e-20_wp   ! module constants
-   REAL(wp) ::   eps16 = 1.e-16_wp   !    -       -
-   REAL(wp) ::   eps13 = 1.e-13_wp   !    -       -
-   REAL(wp) ::   eps10 = 1.e-10_wp   !    -       -
-   REAL(wp) ::   eps06 = 1.e-06_wp   !    -       -
+   REAL(wp) ::   epsi20 = 1.e-20_wp   ! module constants
+   REAL(wp) ::   epsi16 = 1.e-16_wp   !    -       -
+   REAL(wp) ::   epsi13 = 1.e-13_wp   !    -       -
+   REAL(wp) ::   epsi10 = 1.e-10_wp   !    -       -
+   REAL(wp) ::   epsi06 = 1.e-06_wp   !    -       -
    REAL(wp) ::   zzero = 0.e0        !    -       -
    REAL(wp) ::   zone  = 1.e0        !    -       -
@@ -96,5 +98,5 @@
       !
       INTEGER  ::   ji, jj, jk, jl   ! dummy loop indices
-      REAL(wp) ::   zinda
+      REAL(wp) ::   zinda, zindb
       !!------------------------------------------------------------------
 
@@ -115,6 +117,6 @@
                at_i(ji,jj) = at_i(ji,jj) + a_i(ji,jj,jl) ! ice concentration
                !
-               zinda = MAX( zzero , SIGN( zone , at_i(ji,jj) - 0.10 ) ) 
-               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , eps16 ) * zinda  ! ice thickness
+               zinda = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi16 ) ) 
+               icethi(ji,jj) = vt_i(ji,jj) / MAX( at_i(ji,jj) , epsi16 ) * zinda  ! ice thickness
             END DO
          END DO
@@ -136,13 +138,13 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
+                  zinda = MAX( zzero , SIGN( zone , vt_i(ji,jj) - epsi16 ) ) 
+                  zindb = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi16 ) ) 
                   et_s(ji,jj)  = et_s(ji,jj)  + e_s(ji,jj,1,jl)                                       ! snow heat content
-                  zinda = MAX( zzero , SIGN( zone , vt_i(ji,jj) - 0.10 ) ) 
-                  smt_i(ji,jj) = smt_i(ji,jj) + smv_i(ji,jj,jl) / MAX( vt_i(ji,jj) , eps13 ) * zinda   ! ice salinity
-                  zinda = MAX( zzero , SIGN( zone , at_i(ji,jj) - 0.10 ) ) 
-                  ot_i(ji,jj)  = ot_i(ji,jj)  + oa_i(ji,jj,jl)  / MAX( at_i(ji,jj) , eps13 ) * zinda   ! ice age
-               END DO
-            END DO
-         END DO
-         !
+                  smt_i(ji,jj) = smt_i(ji,jj) + smv_i(ji,jj,jl) / MAX( vt_i(ji,jj) , epsi16 ) * zinda   ! ice salinity
+                  ot_i(ji,jj)  = ot_i(ji,jj)  + oa_i(ji,jj,jl)  / MAX( at_i(ji,jj) , epsi16 ) * zindb   ! ice age
+               END DO
+            END DO
+         END DO
+          !
          DO jl = 1, jpl
             DO jk = 1, nlay_i
@@ -174,8 +176,8 @@
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp,- a_i(ji,jj,jl) ) )   !0 if no ice and 1 if yes
-               ht_i(ji,jj,jl) = v_i (ji,jj,jl) / MAX( a_i(ji,jj,jl) , eps10 ) * zindb
-               ht_s(ji,jj,jl) = v_s (ji,jj,jl) / MAX( a_i(ji,jj,jl) , eps10 ) * zindb
-               o_i(ji,jj,jl)  = oa_i(ji,jj,jl) / MAX( a_i(ji,jj,jl) , eps10 ) * zindb
+               zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp,- a_i(ji,jj,jl) + epsi10 ) )   !0 if no ice and 1 if yes
+               ht_i(ji,jj,jl) = v_i (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi10 ) * zindb
+               ht_s(ji,jj,jl) = v_s (ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi10 ) * zindb
+               o_i(ji,jj,jl)  = oa_i(ji,jj,jl) / MAX( a_i(ji,jj,jl) , epsi10 ) * zindb
             END DO
          END DO
@@ -186,6 +188,6 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp,- a_i(ji,jj,jl) ) )   !0 if no ice and 1 if yes
-                  sm_i(ji,jj,jl) = smv_i(ji,jj,jl) / MAX( v_i(ji,jj,jl) , eps10 ) * zindb
+                  zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp,- a_i(ji,jj,jl) + epsi10 ) )   !0 if no ice and 1 if yes
+                  sm_i(ji,jj,jl) = smv_i(ji,jj,jl) / MAX( v_i(ji,jj,jl) , epsi10 ) * zindb
                END DO
             END DO
@@ -207,5 +209,5 @@
                DO ji = 1, jpi
                   !                                                              ! Energy of melting q(S,T) [J.m-3]
-                  zq_i    = e_i(ji,jj,jk,jl) / area(ji,jj) / MAX( v_i(ji,jj,jl) , eps06 ) * REAL(nlay_i,wp) 
+                  zq_i    = e_i(ji,jj,jk,jl) / area(ji,jj) / MAX( v_i(ji,jj,jl) , epsi06 ) * REAL(nlay_i,wp) 
                   zindb   = 1.0 - MAX( 0.0 , SIGN( 1.0 , - v_i(ji,jj,jl) ) )     ! zindb = 0 if no ice and 1 if yes
                   zq_i    = zq_i * unit_fac * zindb                              !convert units
@@ -233,5 +235,5 @@
                DO ji = 1, jpi
                   !Energy of melting q(S,T) [J.m-3]
-                  zq_s  = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , eps06 ) ) * REAL(nlay_s,wp)
+                  zq_s  = e_s(ji,jj,jk,jl) / ( area(ji,jj) * MAX( v_s(ji,jj,jl) , epsi06 ) ) * REAL(nlay_s,wp)
                   zindb = 1._wp - MAX( 0._wp , SIGN( 1._wp , - v_s(ji,jj,jl) ) )     ! zindb = 0 if no ice and 1 if yes
                   zq_s  = zq_s * unit_fac * zindb                                    ! convert units
@@ -252,8 +254,7 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zindb = (  1._wp - MAX( 0._wp , SIGN( 1._wp , -a_i(ji,jj,jl) ) )  )   &
-                     &  * (  1._wp - MAX( 0._wp , SIGN( 1._wp , -v_i(ji,jj,jl) ) )  )
-                  tm_i(ji,jj) = tm_i(ji,jj) + t_i(ji,jj,jk,jl) * v_i(ji,jj,jl)   &
-                     &                      / (  REAL(nlay_i,wp) * MAX( vt_i(ji,jj) , eps10 )  )
+                  zindb = (  1._wp - MAX( 0._wp , SIGN( 1._wp , - vt_i(ji,jj) + epsi10 ) )  )
+                  tm_i(ji,jj) = tm_i(ji,jj) + zindb * t_i(ji,jj,jk,jl) * v_i(ji,jj,jl)   &
+                     &                      / (  REAL(nlay_i,wp) * MAX( vt_i(ji,jj) , epsi10 )  )
                END DO
             END DO
@@ -337,16 +338,16 @@
                DO ji = 1, jpi
                   ! zind0 = 1 if sm_i le s_i_0 and 0 otherwise
-                  zind0  = MAX( 0.0   , SIGN( 1.0  , s_i_0 - sm_i(ji,jj,jl) ) ) 
+                  zind0  = MAX( 0._wp   , SIGN( 1._wp  , s_i_0 - sm_i(ji,jj,jl) ) ) 
                   ! zind01 = 1 if sm_i is between s_i_0 and s_i_1 and 0 othws 
-                  zind01 = ( 1.0 - zind0 ) * MAX( 0.0   , SIGN( 1.0  , s_i_1 - sm_i(ji,jj,jl) ) ) 
+                  zind01 = ( 1._wp - zind0 ) * MAX( 0._wp   , SIGN( 1._wp  , s_i_1 - sm_i(ji,jj,jl) ) ) 
                   ! If 2.sm_i GE sss_m then zindbal = 1
-                  zindbal = MAX( 0.0 , SIGN( 1.0 , 2. * sm_i(ji,jj,jl) - sss_m(ji,jj) ) )
-                  zalpha(ji,jj,jl) = zind0  * 1.0 + zind01 * ( sm_i(ji,jj,jl) * dummy_fac0 + dummy_fac1 )
-                  zalpha(ji,jj,jl) = zalpha(ji,jj,jl) * ( 1.0 - zindbal )
-               END DO
-            END DO
-         END DO
-
-         dummy_fac = 1._wp / nlay_i                   ! Computation of the profile
+                  zindbal = MAX( 0._wp , SIGN( 1._wp , 2._wp * sm_i(ji,jj,jl) - sss_m(ji,jj) ) )
+                  zalpha(ji,jj,jl) = zind0  + zind01 * ( sm_i(ji,jj,jl) * dummy_fac0 + dummy_fac1 )
+                  zalpha(ji,jj,jl) = zalpha(ji,jj,jl) * ( 1._wp - zindbal )
+               END DO
+            END DO
+         END DO
+
+         dummy_fac = 1._wp / REAL( nlay_i )                   ! Computation of the profile
          DO jl = 1, jpl
             DO jk = 1, nlay_i
@@ -388,4 +389,31 @@
 
 
+   SUBROUTINE lim_var_icetm
+      !!------------------------------------------------------------------
+      !!                ***  ROUTINE lim_var_icetm ***
+      !!
+      !! ** Purpose :   computes mean sea ice temperature
+      !!------------------------------------------------------------------
+      INTEGER  ::   ji, jj, jk, jl   ! dummy loop indices
+      REAL(wp) ::   zindb   !   -      -
+      !!------------------------------------------------------------------
+
+      ! Mean sea ice temperature
+      tm_i(:,:) = 0._wp
+      DO jl = 1, jpl
+         DO jk = 1, nlay_i
+            DO jj = 1, jpj
+               DO ji = 1, jpi
+                  zindb = (  1._wp - MAX( 0._wp , SIGN( 1._wp , - vt_i(ji,jj) + epsi10 ) )  )
+                  tm_i(ji,jj) = tm_i(ji,jj) + zindb * t_i(ji,jj,jk,jl) * v_i(ji,jj,jl)   &
+                     &                      / (  REAL(nlay_i,wp) * MAX( vt_i(ji,jj) , epsi10 )  )
+               END DO
+            END DO
+         END DO
+      END DO
+
+   END SUBROUTINE lim_var_icetm
+
+
    SUBROUTINE lim_var_bv
       !!------------------------------------------------------------------
@@ -399,5 +427,5 @@
       !!------------------------------------------------------------------
       INTEGER  ::   ji, jj, jk, jl   ! dummy loop indices
-      REAL(wp) ::   zbvi, zindb      ! local scalars
+      REAL(wp) ::   zbvi, zinda, zindb      ! local scalars
       !!------------------------------------------------------------------
       !
@@ -407,8 +435,9 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zindb = 1.0-MAX(0.0,SIGN(1.0,-a_i(ji,jj,jl))) !0 if no ice and 1 if yes
-                  zbvi  = - zindb * tmut * s_i(ji,jj,jk,jl) / MIN( t_i(ji,jj,jk,jl) - 273.15 , eps13 )   &
+                  zinda = (  1._wp - MAX( 0._wp , SIGN( 1._wp , (t_i(ji,jj,jk,jl) - rtt) + epsi16 ) )  )
+                  zindb = (  1._wp - MAX( 0._wp , SIGN( 1._wp , - vt_i(ji,jj) + epsi16 ) )  )
+                  zbvi  = - zinda * tmut * s_i(ji,jj,jk,jl) / MIN( t_i(ji,jj,jk,jl) - rtt, - epsi16 )   &
                      &                   * v_i(ji,jj,jl)    / REAL(nlay_i,wp)
-                  bv_i(ji,jj) = bv_i(ji,jj) + zbvi  / MAX( vt_i(ji,jj) , eps13 )
+                  bv_i(ji,jj) = bv_i(ji,jj) + zindb * zbvi  / MAX( vt_i(ji,jj) , epsi16 )
                END DO
             END DO
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limwri.F90	(revision 3938)
@@ -10,4 +10,5 @@
    !!   lim_wri      : write of the diagnostics variables in ouput file 
    !!   lim_wri_init : initialization and namelist read
+   !!   lim_wri_state : write for initial state or/and abandon
    !!----------------------------------------------------------------------
    USE ioipsl
@@ -25,4 +26,7 @@
    USE wrk_nemo        ! work arrays
    USE par_ice
+   USE iom
+   USE timing          ! Timing
+   USE lib_fortran     ! Fortran utilities
 
    IMPLICIT NONE
@@ -30,6 +34,7 @@
 
    PUBLIC lim_wri        ! routine called by lim_step.F90
-
-   INTEGER, PARAMETER ::   jpnoumax = 40   !: maximum number of variable for ice output
+   PUBLIC lim_wri_state  ! called by dia_wri_state 
+
+   INTEGER, PARAMETER ::   jpnoumax = 43   !: maximum number of variable for ice output
    
    INTEGER  ::   noumef             ! number of fields
@@ -47,5 +52,5 @@
    INTEGER            , DIMENSION(jpnoumax) ::   nc  , nca     ! switch for saving field ( = 1 ) or not ( = 0 )
 
-   REAL(wp)  ::   epsi16 = 1e-16_wp
+   REAL(wp)  ::   epsi06 = 1e-6_wp
    REAL(wp)  ::   zzero  = 0._wp
    REAL(wp)  ::   zone   = 1._wp      
@@ -76,5 +81,5 @@
       INTEGER ::  ierr
       REAL(wp),DIMENSION(1) ::   zdept
-      REAL(wp) ::  zsto, zjulian, zout, zindh, zinda, zindb
+      REAL(wp) ::  zsto, zjulian, zout, zindh, zinda, zindb, zindc
       REAL(wp), POINTER, DIMENSION(:,:,:) ::   zcmo, zcmoa
       REAL(wp), POINTER, DIMENSION(:,:  ) ::   zfield
@@ -88,4 +93,6 @@
       INTEGER , ALLOCATABLE, DIMENSION(:), SAVE ::   ndexitd
       !!-------------------------------------------------------------------
+
+      IF( nn_timing == 1 )  CALL timing_start('limwri')
 
       CALL wrk_alloc( jpi, jpj, zfield )
@@ -126,5 +133,5 @@
          CALL ymds2ju ( nyear, nmonth, nday, rdt, zjulian )
          zjulian = zjulian - adatrj   !   set calendar origin to the beginning of the experiment
-         CALL dia_nam ( clhstnam, nwrite, 'icemod' )
+         CALL dia_nam ( clhstnam, nwrite, 'icemod_old' )
          CALL histbeg ( clhstnam, jpi, glamt, jpj, gphit, 1, jpi, 1, jpj, niter, zjulian, rdt_ice,   &
             &           nhorid, nice, domain_id=nidom, snc4chunks=snc4set )
@@ -158,6 +165,5 @@
             nhorida,                   & ! ? linked with horizontal ...
             nicea , domain_id=nidom, snc4chunks=snc4set)                  ! file 
-         CALL histvert( nicea, "icethi", "L levels",               &
-            "m", ipl , hi_mean , nz )
+         CALL histvert( nicea, "icethi", "L levels","m", ipl , hi_mean , nz )
          DO jl = 1, jpl
             zmaskitd(:,:,jl) = tmask(:,:,1)
@@ -197,36 +203,40 @@
       zcmoa( 1:jpi, 1:jpj, 1:jpnoumax ) = 0._wp
 
+      ! Ice surface temperature and some fluxes
       DO jl = 1, jpl
          DO jj = 1, jpj
             DO ji = 1, jpi
-               zindh  = MAX( zzero , SIGN( zone , vt_i(ji,jj) * at_i(ji,jj) - 0.10 ) )
-               zinda  = MAX( zzero , SIGN( zone , at_i(ji,jj) - 0.10 ) )
+               zinda  = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi06 ) )
                zcmo(ji,jj,17) = zcmo(ji,jj,17) + a_i(ji,jj,jl)*qsr_ice (ji,jj,jl) 
                zcmo(ji,jj,18) = zcmo(ji,jj,18) + a_i(ji,jj,jl)*qns_ice(ji,jj,jl) 
-               zcmo(ji,jj,27) = zcmo(ji,jj,27) + t_su(ji,jj,jl)*a_i(ji,jj,jl)/MAX(at_i(ji,jj),epsi16)*zinda
+               zcmo(ji,jj,27) = zcmo(ji,jj,27) + zinda*(t_su(ji,jj,jl)-rtt)*a_i(ji,jj,jl)/MAX(at_i(ji,jj),epsi06)
+               zcmo(ji,jj,21) = zcmo(ji,jj,21) + zinda*oa_i(ji,jj,jl)/MAX(at_i(ji,jj),epsi06) 
             END DO
          END DO
       END DO
 
+      ! Mean sea ice temperature
+      CALL lim_var_icetm
+
+      ! Brine volume
       CALL lim_var_bv
 
       DO jj = 2 , jpjm1
          DO ji = 2 , jpim1
-            zindh  = MAX( zzero , SIGN( zone , vt_i(ji,jj) * at_i(ji,jj) - 0.10 ) )
-            zinda  = MAX( zzero , SIGN( zone , at_i(ji,jj) - 0.10 ) )
-            zindb  = zindh * zinda
+            zinda  = MAX( zzero , SIGN( zone , at_i(ji,jj) - epsi06 ) )
+            zindb  = MAX( zzero , SIGN( zone , at_i(ji,jj) ) )
 
             zcmo(ji,jj,1)  = at_i(ji,jj)
-            zcmo(ji,jj,2)  = vt_i(ji,jj) / MAX( at_i(ji,jj), epsi16 ) * zinda
-            zcmo(ji,jj,3)  = vt_s(ji,jj) / MAX( at_i(ji,jj), epsi16 ) * zinda
-            zcmo(ji,jj,4)  = diag_bot_gr(ji,jj) * 86400.0 * zinda    ! Bottom thermodynamic ice production
-            zcmo(ji,jj,5)  = diag_dyn_gr(ji,jj) * 86400.0 * zinda    ! Dynamic ice production (rid/raft)
-            zcmo(ji,jj,22) = diag_lat_gr(ji,jj) * 86400.0 * zinda    ! Lateral thermodynamic ice production
-            zcmo(ji,jj,23) = diag_sni_gr(ji,jj) * 86400.0 * zinda    ! Snow ice production ice production
-            zcmo(ji,jj,24) = tm_i(ji,jj) - rtt
-
-            zcmo(ji,jj,6)  = fbif  (ji,jj)
-            zcmo(ji,jj,7)  = zindb * (  u_ice(ji,jj) * tmu(ji,jj) + u_ice(ji-1,jj) * tmu(ji-1,jj) ) * 0.5_wp
-            zcmo(ji,jj,8)  = zindb * (  v_ice(ji,jj) * tmv(ji,jj) + v_ice(ji,jj-1) * tmv(ji,jj-1) ) * 0.5_wp
+            zcmo(ji,jj,2)  = vt_i(ji,jj) / MAX( at_i(ji,jj), epsi06 ) * zinda
+            zcmo(ji,jj,3)  = vt_s(ji,jj) / MAX( at_i(ji,jj), epsi06 ) * zinda
+            zcmo(ji,jj,4)  = diag_bot_gr(ji,jj) * 86400.0     ! Bottom thermodynamic ice production
+            zcmo(ji,jj,5)  = diag_dyn_gr(ji,jj) * 86400.0     ! Dynamic ice production (rid/raft)
+            zcmo(ji,jj,22) = diag_lat_gr(ji,jj) * 86400.0     ! Lateral thermodynamic ice production
+            zcmo(ji,jj,23) = diag_sni_gr(ji,jj) * 86400.0     ! Snow ice production ice production
+            zcmo(ji,jj,24) = (tm_i(ji,jj) - rtt) * zinda
+
+            zcmo(ji,jj,6)  = fbif(ji,jj)*at_i(ji,jj)
+            zcmo(ji,jj,7)  = (  u_ice(ji,jj) * tmu(ji,jj) + u_ice(ji-1,jj) * tmu(ji-1,jj) ) * 0.5_wp
+            zcmo(ji,jj,8)  = (  v_ice(ji,jj) * tmv(ji,jj) + v_ice(ji,jj-1) * tmv(ji,jj-1) ) * 0.5_wp
             zcmo(ji,jj,9)  = sst_m(ji,jj)
             zcmo(ji,jj,10) = sss_m(ji,jj)
@@ -242,5 +252,4 @@
             zcmo(ji,jj,19) = sprecip(ji,jj)
             zcmo(ji,jj,20) = smt_i(ji,jj)
-            zcmo(ji,jj,21) = ot_i(ji,jj)
             zcmo(ji,jj,25) = et_i(ji,jj)
             zcmo(ji,jj,26) = et_s(ji,jj)
@@ -249,12 +258,21 @@
 
             zcmo(ji,jj,30) = bv_i(ji,jj)
-            zcmo(ji,jj,31) = hicol(ji,jj)
+            zcmo(ji,jj,31) = hicol(ji,jj) * zindb
             zcmo(ji,jj,32) = strength(ji,jj)
             zcmo(ji,jj,33) = SQRT(  zcmo(ji,jj,7)*zcmo(ji,jj,7) + zcmo(ji,jj,8)*zcmo(ji,jj,8)  )
-            zcmo(ji,jj,34) = diag_sur_me(ji,jj) * 86400.0 * zinda    ! Surface melt
-            zcmo(ji,jj,35) = diag_bot_me(ji,jj) * 86400.0 * zinda    ! Bottom melt
+            zcmo(ji,jj,34) = diag_sur_me(ji,jj) * 86400.0     ! Surface melt
+            zcmo(ji,jj,35) = diag_bot_me(ji,jj) * 86400.0     ! Bottom melt
             zcmo(ji,jj,36) = divu_i(ji,jj)
             zcmo(ji,jj,37) = shear_i(ji,jj)
-         END DO
+            zcmo(ji,jj,38) = diag_res_pr(ji,jj) * 86400.0     ! Bottom melt
+            zcmo(ji,jj,39) = vt_i(ji,jj)  ! ice volume
+            zcmo(ji,jj,40) = vt_s(ji,jj)  ! snow volume
+
+            zcmo(ji,jj,41) = fsalt_rpo(ji,jj)
+            zcmo(ji,jj,42) = fsalt_res(ji,jj)
+
+            zcmo(ji,jj,43) = diag_trp_vi(ji,jj) * 86400.0     ! transport of ice volume
+
+        END DO
       END DO
 
@@ -285,4 +303,46 @@
       ENDIF
 
+       CALL iom_put ('iceconc', zcmo(:,:,1) )          ! field1: ice concentration
+       CALL iom_put ('icethic_cea', zcmo(:,:,2) )      ! field2: ice thickness (i.e. icethi(:,:))
+       CALL iom_put ('snowthic_cea', zcmo(:,:,3))      ! field3: snow thickness
+       CALL iom_put ('icebopr', zcmo(:,:,4) )   ! field4: daily bottom thermo ice production
+       CALL iom_put ('icedypr', zcmo(:,:,5) )   ! field5: daily dynamic ice production
+       CALL iom_put ('ioceflxb', zcmo(:,:,6) )         ! field6: Oceanic flux at the ice base
+       CALL iom_put ('uice_ipa', zcmo(:,:,7) )         ! field7: ice velocity u component
+       CALL iom_put ('vice_ipa', zcmo(:,:,8) )         ! field8: ice velocity v component
+       CALL iom_put ('isst', zcmo(:,:,9) )             ! field 9: sea surface temperature
+       CALL iom_put ('isss', zcmo(:,:,10) )            ! field 10: sea surface salinity
+       CALL iom_put ('qt_oc', zcmo(:,:,11) )           ! field 11: total flux at ocean surface
+       CALL iom_put ('qsr_oc', zcmo(:,:,12) )          ! field 12: solar flux at ocean surface
+       CALL iom_put ('qns_oc', zcmo(:,:,13) )          ! field 13: non-solar flux at ocean surface
+       !CALL iom_put ('hfbri', fhbri )                  ! field 14: heat flux due to brine release
+       CALL iom_put ('qsr_io', zcmo(:,:,17) )          ! field 17: solar flux at ice/ocean surface
+       CALL iom_put ('qns_io', zcmo(:,:,18) )          ! field 18: non-solar flux at ice/ocean surface
+       !CALL iom_put ('snowpre', zcmo(:,:,19) * 86400) ! field 19 :snow precip          
+       CALL iom_put ('micesalt', zcmo(:,:,20) )        ! field 20 :mean ice salinity
+       CALL iom_put ('miceage', zcmo(:,:,21) / 365)    ! field 21: mean ice age
+       CALL iom_put ('icelapr',zcmo(:,:,22) )   ! field 22: daily lateral thermo ice prod.
+       CALL iom_put ('icesipr',zcmo(:,:,23) )   ! field 23: daily snowice ice prod.
+       CALL iom_put ('micet', zcmo(:,:,24) )           ! field 24: mean ice temperature
+       CALL iom_put ('icehc', zcmo(:,:,25) )           ! field 25: ice total heat content
+       CALL iom_put ('isnowhc', zcmo(:,:,26) )         ! field 26: snow total heat content
+       CALL iom_put ('icest', zcmo(:,:,27) )           ! field 27: ice surface temperature
+       CALL iom_put ('fsbri', zcmo(:,:,28) * 86400 )           ! field 28: brine salt flux
+       CALL iom_put ('fseqv', zcmo(:,:,29) * 86400 )           ! field 29: equivalent FW salt flux
+       CALL iom_put ('ibrinv', zcmo(:,:,30) *100 )     ! field 30: brine volume
+       CALL iom_put ('icecolf', zcmo(:,:,31) )         ! field 31: frazil ice collection thickness
+       CALL iom_put ('icestr', zcmo(:,:,32) * 0.001 )  ! field 32: ice strength
+       CALL iom_put ('icevel', zcmo(:,:,33) )          ! field 33: ice velocity
+       CALL iom_put ('isume', zcmo(:,:,34) )    ! field 34: surface melt
+       CALL iom_put ('ibome', zcmo(:,:,35) )     ! field 35: bottom melt
+       CALL iom_put ('idive', zcmo(:,:,36) * 1.0e8)    ! field 36: divergence
+       CALL iom_put ('ishear', zcmo(:,:,37) * 1.0e8 )  ! field 37: shear
+       CALL iom_put ('icerepr', zcmo(:,:,38) ) ! field 38: daily prod./melting due to limupdate
+       CALL iom_put ('icevolu', zcmo(:,:,39) ) ! field 39: ice volume
+       CALL iom_put ('snowvol', zcmo(:,:,40) ) ! field 40: snow volume
+       CALL iom_put ('fsrpo', zcmo(:,:,41) * 86400 )           ! field 41: salt flux from ridging rafting
+       CALL iom_put ('fsres', zcmo(:,:,42) * 86400 )           ! field 42: salt flux from limupdate (resultant)
+       CALL iom_put ('icetrp', zcmo(:,:,43) )    ! field 43: ice volume transport
+
       !-----------------------------
       ! Thickness distribution file
@@ -302,6 +362,6 @@
             DO jj = 1, jpj
                DO ji = 1, jpi
-                  zinda = MAX( zzero , SIGN( zone , a_i(ji,jj,jl) - 1.0e-6 ) )
-                  zoi(ji,jj,jl) = oa_i(ji,jj,jl)  / MAX( a_i(ji,jj,jl) , 1.0e-6 ) * zinda
+                  zinda = MAX( zzero , SIGN( zone , a_i(ji,jj,jl) - epsi06 ) )
+                  zoi(ji,jj,jl) = oa_i(ji,jj,jl)  / MAX( a_i(ji,jj,jl) , epsi06 ) * zinda
                END DO
             END DO
@@ -314,7 +374,7 @@
                DO jj = 1, jpj
                   DO ji = 1, jpi
-                     zinda = MAX( zzero , SIGN( zone , a_i(ji,jj,jl) - 1.0e-6 ) )
+                     zinda = MAX( zzero , SIGN( zone , a_i(ji,jj,jl) - epsi06 ) )
                      zei(ji,jj,jl) = zei(ji,jj,jl) + 100.0* &
-                        ( - tmut * s_i(ji,jj,jk,jl) / MIN( ( t_i(ji,jj,jk,jl) - rtt ), -1.0e-6 ) ) * &
+                        ( - tmut * s_i(ji,jj,jk,jl) / MIN( ( t_i(ji,jj,jk,jl) - rtt ), - epsi06 ) ) * &
                         zinda / nlay_i
                   END DO
@@ -348,4 +408,6 @@
       CALL wrk_dealloc( jpi, jpj, jpnoumax, zcmo, zcmoa )
       CALL wrk_dealloc( jpi, jpj, jpl, zmaskitd, zoi, zei )
+
+      IF( nn_timing == 1 )  CALL timing_stop('limwri')
       
    END SUBROUTINE lim_wri
@@ -381,5 +443,5 @@
          field_25, field_26, field_27, field_28, field_29, field_30,   &
          field_31, field_32, field_33, field_34, field_35, field_36,   &
-         field_37
+         field_37, field_38, field_39, field_40, field_41, field_42, field_43
 
       TYPE(FIELD) , DIMENSION(jpnoumax) :: zfield
@@ -392,5 +454,5 @@
          field_25, field_26, field_27, field_28, field_29, field_30,   &
          field_31, field_32, field_33, field_34, field_35, field_36,   &
-         field_37, add_diag_swi
+         field_37, field_38, field_39, field_40, field_41, field_42, field_43, add_diag_swi
       !!-------------------------------------------------------------------
 
@@ -435,4 +497,10 @@
       zfield(36) = field_36
       zfield(37) = field_37
+      zfield(38) = field_38
+      zfield(39) = field_39
+      zfield(40) = field_40
+      zfield(41) = field_41
+      zfield(42) = field_42
+      zfield(43) = field_43
 
       DO nf = 1, noumef
@@ -460,4 +528,63 @@
       !
    END SUBROUTINE lim_wri_init
+ 
+   SUBROUTINE lim_wri_state( kt, kid, kh_i )
+      !!---------------------------------------------------------------------
+      !!                 ***  ROUTINE lim_wri_state  ***
+      !!        
+      !! ** Purpose :   create a NetCDF file named cdfile_name which contains 
+      !!      the instantaneous ice state and forcing fields for ice model
+      !!        Used to find errors in the initial state or save the last
+      !!      ocean state in case of abnormal end of a simulation
+      !!
+      !! History :
+      !!   4.1  !  2013-06  (C. Rousset)
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   kt               ! ocean time-step index)
+      INTEGER, INTENT( in ) ::   kid , kh_i       
+      !!----------------------------------------------------------------------
+      !CALL histvert( kid, "icethi", "L levels","m", jpl , hi_mean , nz )
+
+      CALL histdef( kid, "iicethic", "Ice thickness"           , "m"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iiceconc", "Ice concentration"       , "%"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicetemp", "Ice temperature"         , "C"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicevelu", "i-Ice speed (I-point)"   , "m/s"    , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicevelv", "j-Ice speed (I-point)"   , "m/s"    , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicestru", "i-Wind stress over ice (I-pt)", "Pa", jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "iicestrv", "j-Wind stress over ice (I-pt)", "Pa", jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicesflx", "Solar flux over ocean"     , "w/m2"   , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicenflx", "Non-solar flux over ocean" , "w/m2"   , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt )
+      CALL histdef( kid, "isnowpre", "Snow precipitation"      , "kg/m2/s", jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicesali", "Ice salinity"            , "PSU"    , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicevolu", "Ice volume"              , "m"      , jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+      CALL histdef( kid, "iicedive", "Ice divergence"          , "10-8s-1", jpi, jpj, kh_i, 1, 1, 1, -99, 32, "inst(x)", rdt, rdt ) 
+
+      !CALL histdef( kid, "iice_itd", "Ice concentration by cat", "%"      , jpi, jpj, kh_i, jpl, 1, jpl, -99, 32, "inst(x)", rdt, rdt ) 
+      !CALL histdef( kid, "iice_hid", "Ice thickness by cat"    , "m"      , jpi, jpj, kh_i, jpl, 1, jpl, -99, 32, "inst(x)", rdt, rdt ) 
+      !CALL histdef( kid, "iice_hsd", "Snow thickness by cat"   , "m"      , jpi, jpj, kh_i, jpl, 1, jpl, -99, 32, "inst(x)", rdt, rdt ) 
+      !CALL histdef( kid, "iice_std", "Ice salinity by cat"     , "PSU"    , jpi, jpj, kh_i, jpl, 1, jpl, -99, 32, "inst(x)", rdt, rdt ) 
+
+      CALL histend( kid, snc4set )   ! end of the file definition
+
+      CALL histwrite( kid, "iicethic", kt, icethi        , jpi*jpj, (/1/) )    
+      CALL histwrite( kid, "iiceconc", kt, at_i          , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicetemp", kt, tm_i - rtt    , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicevelu", kt, u_ice          , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicevelv", kt, v_ice          , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicestru", kt, utau_ice       , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicestrv", kt, vtau_ice       , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicesflx", kt, qsr , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicenflx", kt, qns , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "isnowpre", kt, sprecip        , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicesali", kt, smt_i          , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicevolu", kt, vt_i           , jpi*jpj, (/1/) )
+      CALL histwrite( kid, "iicedive", kt, divu_i*1.0e8   , jpi*jpj, (/1/) )
+
+      !CALL histwrite( kid, "iice_itd", kt, a_i  , jpi*jpj*jpl, (/1/)  )   ! area
+      !CALL histwrite( kid, "iice_hid", kt, ht_i , jpi*jpj*jpl, (/1/)  )   ! thickness
+      !CALL histwrite( kid, "iice_hsd", kt, ht_s , jpi*jpj*jpl, (/1/)  )   ! snow depth
+      !CALL histwrite( kid, "iice_std", kt, sm_i , jpi*jpj*jpl, (/1/)  )   ! salinity
+
+    END SUBROUTINE lim_wri_state
 
 #else
Index: /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limwri_dimg.h90
===================================================================
--- /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limwri_dimg.h90	(revision 3937)
+++ /branches/2013/dev_r3406_CNRS_LIM3/NEMOGCM/NEMO/LIM_SRC_3/limwri_dimg.h90	(revision 3938)
@@ -111,5 +111,5 @@
          zcmo(ji,jj,13) = qns(ji,jj)
          ! See thersf for the coefficient
-         zcmo(ji,jj,14) = - emps(ji,jj) * rday * ( sss_m(ji,jj) + epsi16 ) / soce
+         zcmo(ji,jj,14) = - emps(ji,jj) * rday     ! converted in Kg/m2/day = mm/day
          zcmo(ji,jj,15) = utau_ice(ji,jj)
          zcmo(ji,jj,16) = vtau_ice(ji,jj)
@@ -154,5 +154,5 @@
                rcmoy(ji,jj,13) = qns(ji,jj)
                ! See thersf for the coefficient
-               rcmoy(ji,jj,14) = - emps(ji,jj) * rday * ( sss_m(ji,jj) + epsi16 ) / soce
+               rcmoy(ji,jj,14) = - emps(ji,jj) * rday     ! converted in Kg/m2/day = mm/day
                rcmoy(ji,jj,15) = utau_ice(ji,jj)
                rcmoy(ji,jj,16) = vtau_ice(ji,jj)
